/**
 * 
 */
package org.gcube.portlets.user.td.gwtservice.client.rpc;



import java.util.ArrayList;
import java.util.List;



import org.gcube.portlets.user.td.gwtservice.shared.Agencies;
import org.gcube.portlets.user.td.gwtservice.shared.Codelist;
import org.gcube.portlets.user.td.gwtservice.shared.Dataset;
import org.gcube.portlets.user.td.gwtservice.shared.TDGWTServiceException;
import org.gcube.portlets.user.td.gwtservice.shared.TDOpenSession;
import org.gcube.portlets.user.td.gwtservice.shared.TabResource;
import org.gcube.portlets.user.td.gwtservice.shared.csv.AvailableCharsetList;
import org.gcube.portlets.user.td.gwtservice.shared.csv.CSVImportMonitor;
import org.gcube.portlets.user.td.gwtservice.shared.csv.CSVImportSession;
import org.gcube.portlets.user.td.gwtservice.shared.csv.CSVRowError;
import org.gcube.portlets.user.td.gwtservice.shared.file.FileUploadMonitor;
import org.gcube.portlets.user.td.gwtservice.shared.file.HeaderPresence;
import org.gcube.portlets.user.td.gwtservice.shared.sdmx.SDMXImportMonitor;
import org.gcube.portlets.user.td.gwtservice.shared.sdmx.SDMXImportSession;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;
 
/**
 * 
 * @author "Giancarlo Panichi" <a
 *         href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a>
 * 
 */
@RemoteServiceRelativePath("TDGWTService")
public interface TDGWTService extends RemoteService {

	public TabResource getTabResource() throws TDGWTServiceException;
	
	public void setTabResource(TabResource tr) throws TDGWTServiceException;
	
	public List<TabResource> getTabularResources() throws TDGWTServiceException;	
	
	public TabResource createTabularResource(TabResource tabResource) throws TDGWTServiceException;
	
	//Open 
	public void setTDOpenSession(TDOpenSession s) throws TDGWTServiceException;
	
	//Import SDMX
	public ArrayList<Codelist> getCodelists() throws TDGWTServiceException;
	
	public ArrayList<Dataset> getDatasets() throws TDGWTServiceException;
	
	public ArrayList<Agencies> getAgencies() throws TDGWTServiceException;
	
	public void setSDMXSession(SDMXImportSession s) throws TDGWTServiceException;
	
	public SDMXImportMonitor getSDMXImportMonitor() throws TDGWTServiceException;
	
	public void importSDMXClientLibraryRequest(SDMXImportSession s) throws TDGWTServiceException;

	//Import CSV
	public FileUploadMonitor getFileUploadMonitor() throws TDGWTServiceException;

	public CSVImportMonitor getCSVImportMonitor() throws TDGWTServiceException;
	
	public void setCSVSession(CSVImportSession s) throws TDGWTServiceException;
	
	
	public AvailableCharsetList getAvailableCharset() throws TDGWTServiceException;
	
	public ArrayList<String> configureCSVParser(String encoding, HeaderPresence headerPresence, char delimiter, char comment) throws TDGWTServiceException;
	
	public ArrayList<CSVRowError> checkCSV(long errorsLimit) throws TDGWTServiceException;
	
	public void startCSVImport(boolean[] columnToImportMask) throws TDGWTServiceException;
	
}
