package org.gcube.portlets.user.td.gwtservice.server.file;

import java.io.File;
import java.io.Serializable;


import org.gcube.portlets.user.td.gwtservice.shared.csv.CSVImportMonitor;
import org.gcube.portlets.user.td.gwtservice.shared.csv.CSVParserConfiguration;
import org.gcube.portlets.user.td.gwtservice.shared.file.FileUploadMonitor;
import org.gcube.portlets.user.td.gwtservice.shared.file.FileUploadState;

/**
 * 
 * @author "Giancarlo Panichi" 
 * <a href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a> 
 *
 */
public class FileUploadSession implements Serializable {
	
	private static final long serialVersionUID = -7906477664944910362L;
	
	protected String id;
	
	protected FileUploadState fileUploadState;
	
	protected File csvFile;
	protected String csvName;
	
	protected FileUploadMonitor fileUploadMonitor;
	
	protected CSVParserConfiguration parserConfiguration;
	
	protected CSVImportMonitor csvImportMonitor;
	

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public FileUploadState getFileUploadState() {
		return fileUploadState;
	}

	public void setFileUploadState(FileUploadState fileUploadState) {
		this.fileUploadState = fileUploadState;
	}

	public File getCsvFile() {
		return csvFile;
	}

	public void setCsvFile(File csvFile) {
		this.csvFile = csvFile;
	}

	public String getCsvName() {
		return csvName;
	}

	public void setCsvName(String csvName) {
		this.csvName = csvName;
	}

	public FileUploadMonitor getFileUploadMonitor() {
		return fileUploadMonitor;
	}

	public void setFileUploadMonitor(FileUploadMonitor fileUploadMonitor) {
		this.fileUploadMonitor = fileUploadMonitor;
	}

	public CSVParserConfiguration getParserConfiguration() {
		return parserConfiguration;
	}

	public void setParserConfiguration(CSVParserConfiguration parserConfiguration) {
		this.parserConfiguration = parserConfiguration;
	}

	public CSVImportMonitor getCsvImportMonitor() {
		return csvImportMonitor;
	}

	public void setCsvImportMonitor(CSVImportMonitor csvImportMonitor) {
		this.csvImportMonitor = csvImportMonitor;
	}

	@Override
	public String toString() {
		return "FileUploadSession [id=" + id + ", fileUploadState=" + fileUploadState
				+ ", csvFile=" + csvFile + ", csvName=" + csvName
				+ ", fileUploadMonitor=" + fileUploadMonitor
				+ ", parserConfiguration=" + parserConfiguration
				+ ", csvImportMonitor=" + csvImportMonitor +"]";
	}
	
	
		
}
