package org.gcube.portlets.user.td.gwtservice.server.trservice;


/**
 * 
 * @author "Giancarlo Panichi" 
 * <a href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a> 
 *
 * Tabular Data Service Operations Id
 *  
 *  100	CSVImport
 *  101	CSVExport
 *  200	SDMXCodelistImport 
 *  201	SDMXCodelistExport 
 *  202	SDMXDatasetImport 
 *  203	SDMXDatasetExport 
 *  300	JSONImport
 *  301	JSONExport 
 *  1000	ValidateCodelist 
 *  1001	ValidateDataset 
 *  1002	ChangeTableType 
 *  1003	CreateDatasetView 
 *  1004	RemoveColumn 
 *  1005	ChangeLabel 
 *  1006	AddLabel 
 *  1007	RemoveLabel 
 *  2000	ChangeToAnnotationColumn 
 *  2001	ChangeToAttributeColumn 
 *  2002	ChangeToMeasureColumn 
 *  2003	ChangeToCodeColumn 
 *  2004	ChangeToCodeName 
 *  2005	ChangeToCodeDescription 
 *  2006	ChangeToDimensionColumn 
 *  2007	ChangeToTimeDimensionColumn 
 *  3000	ModifyTuplesValues 
 *  3001	ModifyColumnValueOnCondition 
 *  3002	NewAnnotationColumn 
 *  3003	Filter 
 *  3004	Union 
 *  3005	Denormalize 
 *  3006	Aggregate	
 *
 */
public enum OperationsId {
	CSVImport("100"), 
	CSVExport("101"),
	SDMXCodelistImport("200"),	
	SDMXCodelistExport("201"),
	SDMXDatasetImport("202"), 
  	SDMXDatasetExport("203"),
  	JSONImport("300"),	
  	JSONExport("301"),
  	ValidateCodelist("1000"),
	ValidateDataset("1001"), 
	ChangeTableType("1002"), 
	CreateDatasetView("1003"), 
	RemoveColumn("1004"), 
	ChangeLabel("1005"),
	AddLabel("1006"), 
	RemoveLabel("1007"), 
	ChangeToAnnotationColumn("2000"), 
	ChangeToAttributeColumn("2001"), 
	ChangeToMeasureColumn("2002"), 
	ChangeToCodeColumn("2003"),
	ChangeToCodeName("2004"), 
	ChangeToCodeDescription("2005"), 
	ChangeToDimensionColumn("2006"), 
	ChangeToTimeDimensionColumn("2007"),
	ModifyTuplesValues("3000"), 
	ModifyColumnValueOnCondition("3001"), 
	NewAnnotationColumn("3002"),
	Filter("3003"),
	Union("3004"),
	Denormalize("3005"),
	Aggregate("3006");
	
	/**
	 * @param text
	 */
	private OperationsId(final String id) {
		this.id = id;
	}

	private final String id;
	
	@Override
	public String toString() {
		return id;
	}

}


