/**
 * 
 */
package org.gcube.portlets.user.td.gwtservice.shared.csv;

import java.io.Serializable;

/**
 * 
 * @author "Giancarlo Panichi" 
 * <a href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a> 
 *
 */
public class CSVImportMonitor implements Serializable {

	private static final long serialVersionUID = -1150111422206443617L;
	
	protected long totalLenght;
	protected long elaboratedLenght;
	protected CSVImportState state;
	protected String failureReason;
	protected String failureDetails;
	
	public CSVImportMonitor(){
		state = CSVImportState.STARTED;
	}

	public CSVImportMonitor(long totalLenght, long elaboratedLenght, CSVImportState state, String failureReason) {
		this.totalLenght = totalLenght;
		this.elaboratedLenght = elaboratedLenght;
		this.state = state;
		this.failureReason = failureReason;
	}

	/**
	 * @return the totalLenght
	 */
	public long getTotalLenght() {
		return totalLenght;
	}
	
	/**
	 * @return the elaboratedLenght
	 */
	public long getElaboratedLenght() {
		return elaboratedLenght;
	}

	
	public CSVImportState getState(){
		return state;
	}

	/**
	 * @return the failureDetails
	 */
	public String getFailureDetails() {
		return failureDetails;
	}

	public void setState(CSVImportState state)
	{
		this.state = state;
	}

	/**
	 * @return the reason
	 */
	public String getFailureReason() {
		return failureReason;
	}

	/**
	 * @param totalLenght the totalLenght to set
	 */
	public void setTotalLenght(long totalLenght) {
		this.totalLenght = totalLenght;
	}

	/**
	 * @param elaboratedLenght the elaboratedLenght to set
	 */
	public void setElaboratedLenght(long elaboratedLenght) {
		this.elaboratedLenght = elaboratedLenght;
	}

	/**
	 * @param failed the failed to set
	 */
	public void setFailed(String failureReason, String failureDetails) {
		this.state = CSVImportState.FAILED;
		this.failureReason = failureReason;
		this.failureDetails = failureDetails;
	}


	@Override
	public String toString() {
		return "CSVImportMonitor [totalLenght=" + totalLenght
				+ ", elaboratedLenght=" + elaboratedLenght + ", state=" + state
				+ ", failureReason=" + failureReason + ", failureDetails="
				+ failureDetails +  "]";
	}
		
}
